/** ###################################################################
**     Filename  : DC17.C
**     Project   : DC17
**     Processor : MC56F8006_32_LQFP
**     Version   : Driver 01.13
**     Compiler  : Metrowerks DSP C Compiler
**     Date/Time : 8/2/2009, 3:12 PM
**     Abstract  :
**         Main module.
**         This module contains user's application code.
**     Settings  :
**     Contents  :
**         No public methods
**
**     (c) Copyright UNIS, a.s. 1997-2008
**     UNIS, a.s.
**     Jundrovska 33
**     624 00 Brno
**     Czech Republic
**     http      : www.processorexpert.com
**     mail      : info@processorexpert.com
** ###################################################################*/
/* MODULE DC17 */


/* Including needed modules to compile this module/procedure */
#include "Cpu.h"
#include "Events.h"
#include "PWMRed.h"
#include "PWMGreen.h"
#include "PWMBlue.h"
#include "MICOUT.h"
#include "MICPWR.h"
#include "TIPIT.h"
#include "Term1.h"
#include "Inhr6.h"
#include "PORTB5OUT.h"
#include "PORTCIN.h"
#include "PORTFOUT.h"
#include "Inhr3.h"
#include "Inhr4.h"
#include "Inhr5.h"
#include "SPI_FS.h"
#include "SPI_FS_CS.h"
#include "LEDMuxTimer.h"

/* Including shared modules, which are used for whole project */
#include "PE_Types.h"
#include "PE_Error.h"
#include "PE_Const.h"
#include "IO_Map.h"

#include "BBBS.h"

void main(void)
{
  extern word _vba;
    
  INTC_VBA = ((word)&_vba) >> 7;	// restore VBA register to point to user defined vector table

  /*** Processor Expert internal initialization. DON'T REMOVE THIS CODE!!! ***/
  PE_low_level_init();
  /*** End of Processor Expert internal initialization.                    ***/

  bbbs_init();
  bbbs_mainloop();

  Cpu_SetStopMode();
}
