/** ###################################################################
**     THIS BEAN MODULE IS GENERATED BY THE TOOL. DO NOT MODIFY IT.
**     Filename  : SPI_FS.H
**     Project   : DC17
**     Processor : MC56F8006_32_LQFP
**     Beantype  : SWSPI
**     Version   : Bean 01.018, Driver 01.15, CPU db: 3.00.169
**     Compiler  : Metrowerks DSP C Compiler
**     Date/Time : 8/2/2009, 7:31 PM
**     Abstract  :
**          This bean implements an external SPI communication interface specialy 
**          designed for SPI compatible beans. The interface uses three general-purpose 
**          I/O pins, first for the Input line, second for the Output line, third for 
**          the Serial Clock line. Is supported only Master mode with MSB first 
**          communication. 
**     Contents  :
**         RecvChar     - byte SPI_FS_RecvChar(byte *Chr);
**         SendChar     - byte SPI_FS_SendChar(byte Chr);
**         CharsInRxBuf - byte SPI_FS_CharsInRxBuf(word *Chr);
**         CharsInTxBuf - byte SPI_FS_CharsInTxBuf(word *Chr);
**
**     (c) Copyright UNIS, a.s. 1997-2008
**     UNIS, a.s.
**     Jundrovska 33
**     624 00 Brno
**     Czech Republic
**     http      : www.processorexpert.com
**     mail      : info@processorexpert.com
** ###################################################################*/

#ifndef __SPI_FS
#define __SPI_FS

/* MODULE SPI_FS. */

/*Include shared modules, which are used for whole project*/
#include "PE_Types.h"
#include "PE_Error.h"
#include "PE_Const.h"
#include "IO_Map.h"
/* Include inherited beans */
#include "Inhr3.h"
#include "Inhr4.h"
#include "Inhr5.h"

#include "Cpu.h"


#ifndef __BWUserType_TPtrByte
#define __BWUserType_TPtrByte
  typedef byte* TPtrByte ; /* Pointer to byte */
#endif


byte SPI_FS_RecvChar(byte *Chr);
/*
** ===================================================================
**     Method      :  SPI_FS_RecvChar (bean SWSPI)
**
**     Description :
**         If any data received, this method returns one character,
**         otherwise it returns error code (it does not wait for
**         data).
**     Parameters  :
**         NAME            - DESCRIPTION
**       * Chr             - Pointer to received character.
**     Returns     :
**         ---             - Error code, possible codes:
**                           ERR_OK - OK
**                           ERR_RXEMPTY - No data in receiver
**                           ERR_OVERRUN - Overrun error is detected
** ===================================================================
*/

byte SPI_FS_SendChar(byte Chr);
/*
** ===================================================================
**     Method      :  SPI_FS_SendChar (bean SWSPI)
**
**     Description :
**         Send one character to the channel.
**     Parameters  :
**         NAME            - DESCRIPTION
**         Chr             - Character to send.
**     Returns     :
**         ---             - Error code, possible codes:
**                           ERR_OK - OK
** ===================================================================
*/

byte SPI_FS_CharsInRxBuf(word *Chr);
/*
** ===================================================================
**     Method      :  SPI_FS_CharsInRxBuf (bean SWSPI)
**
**     Description :
**         Return number of characters in the input buffer.
**     Parameters  :
**         NAME            - DESCRIPTION
**       * Chr             - Pointer to number of characters in the
**                           input buffer.
**     Returns     :
**         ---             - Error code, possible codes:
**                           ERR_OK - OK
** ===================================================================
*/

byte SPI_FS_CharsInTxBuf(word *Chr);
/*
** ===================================================================
**     Method      :  SPI_FS_CharsInTxBuf (bean SWSPI)
**
**     Description :
**         Return number of characters in the output buffer.
**     Parameters  :
**         NAME            - DESCRIPTION
**       * Chr             - Pointer to number of characters in the
**                           output buffer.
**     Returns     :
**         ---             - Error code, possible codes:
**                           ERR_OK - OK
** ===================================================================
*/

void SPI_FS_Init(void);
/*
** ===================================================================
**     Method      :  SPI_FS_Init (bean SWSPI)
**
**     Description :
**         Initializes the associated peripheral(s) and the beans 
**         internal variables. The method is called automatically as a 
**         part of the application initialization code.
**         This method is internal. It is used by Processor Expert only.
** ===================================================================
*/


/* END SPI_FS. */

#endif /* ifndef __SPI_FS */
/*
** ###################################################################
**
**     This file was created by UNIS Processor Expert 2.99 [04.17]
**     for the Freescale 56800 series of microcontrollers.
**
** ###################################################################
*/
