/** ###################################################################
**     THIS BEAN MODULE IS GENERATED BY THE TOOL. DO NOT MODIFY IT.
**     Filename  : SPI_FS_CS.H
**     Project   : DC17
**     Processor : MC56F8006_32_LQFP
**     Beantype  : BitIO
**     Version   : Bean 02.072, Driver 01.17, CPU db: 3.00.169
**     Compiler  : Metrowerks DSP C Compiler
**     Date/Time : 8/2/2009, 7:53 PM
**     Abstract  :
**         This bean "BitIO" implements an one-bit input/output.
**         It uses one bit/pin of a port.
**         Methods of this bean are mostly implemented as a macros
**         (if supported by target language and compiler).
**     Settings  :
**         Used pin                    :
**             ----------------------------------------------------
**                Number (on package)  |    Name
**             ----------------------------------------------------
**                       2             |  GPIOB1_ANA12_SSB_SDA_CMP2_P3
**             ----------------------------------------------------
**
**         Port name                   : GPIOB
**
**         Bit number (in port)        : 1
**         Bit mask of the port        : 2
**
**         Initial direction           : Output (direction can be changed)
**         Safe mode                   : yes
**         Initial output value        : 1
**         Initial pull option         : off
**
**         Port data register          : GPIO_B_DR [61857]
**         Port control register       : GPIO_B_DDR [61858]
**         Port function register      : GPIO_B_PER [61859]
**
**         Optimization for            : speed
**     Contents  :
**         GetDir - bool SPI_FS_CS_GetDir(void);
**         SetDir - void SPI_FS_CS_SetDir(bool Dir);
**         GetVal - bool SPI_FS_CS_GetVal(void);
**         PutVal - void SPI_FS_CS_PutVal(bool Val);
**         ClrVal - void SPI_FS_CS_ClrVal(void);
**         SetVal - void SPI_FS_CS_SetVal(void);
**
**     (c) Copyright UNIS, a.s. 1997-2008
**     UNIS, a.s.
**     Jundrovska 33
**     624 00 Brno
**     Czech Republic
**     http      : www.processorexpert.com
**     mail      : info@processorexpert.com
** ###################################################################*/

#ifndef __SPI_FS_CS_H
#define __SPI_FS_CS_H

/* MODULE SPI_FS_CS. */

/*Include shared modules, which are used for whole project*/
#include "PE_Types.h"
#include "PE_Error.h"
#include "PE_Const.h"
#include "IO_Map.h"

#include "Cpu.h"


#define SPI_FS_CS_PIN_MASK      ((byte)2) /* Pin mask */


/*
** ===================================================================
**     Method      :  SPI_FS_CS_GetVal (bean BitIO)
**
**     Description :
**         This method returns an input value.
**           a) direction = Input  : reads the input value from the
**                                   pin and returns it
**           b) direction = Output : returns the last written value
**     Parameters  : None
**     Returns     :
**         ---             - Input value. Possible values:
**                           FALSE - logical "0" (Low level)
**                           TRUE - logical "1" (High level)

** ===================================================================
*/
#define SPI_FS_CS_GetVal() ((bool)(getRegBits(GPIO_B_DR,SPI_FS_CS_PIN_MASK)))

/*
** ===================================================================
**     Method      :  SPI_FS_CS_PutVal (bean BitIO)
**
**     Description :
**         This method writes the new output value.
**           a) direction = Input  : sets the new output value;
**                                   this operation will be shown on
**                                   output after the direction has
**                                   been switched to output
**                                   (SetDir(TRUE);)
**           b) direction = Output : directly writes the value to the
**                                   appropriate pin
**     Parameters  :
**         NAME       - DESCRIPTION
**         Val             - Output value. Possible values:
**                           FALSE - logical "0" (Low level)
**                           TRUE - logical "1" (High level)
**     Returns     : Nothing
** ===================================================================
*/
void SPI_FS_CS_PutVal(bool Val);

/*
** ===================================================================
**     Method      :  SPI_FS_CS_SetDir (bean BitIO)
**
**     Description :
**         This method sets direction of the bean.
**     Parameters  :
**         NAME       - DESCRIPTION
**         Dir        - Direction to set (FALSE or TRUE)
**                      FALSE = Input, TRUE = Output
**     Returns     : Nothing
** ===================================================================
*/
void SPI_FS_CS_SetDir(bool Dir);

/*
** ===================================================================
**     Method      :  SPI_FS_CS_GetDir (bean BitIO)
**
**     Description :
**         This method returns direction of the bean.
**     Parameters  : None
**     Returns     :
**         ---        - Direction of the bean (FALSE or TRUE)
**                      FALSE = Input, TRUE = Output
** ===================================================================
*/
#define SPI_FS_CS_GetDir() ((bool)(getRegBits(GPIO_B_DDR,SPI_FS_CS_PIN_MASK)))

/*
** ===================================================================
**     Method      :  SPI_FS_CS_ClrVal (bean BitIO)
**
**     Description :
**         This method clears (sets to zero) the output value.
**           a) direction = Input  : sets the output value to "0";
**                                   this operation will be shown on
**                                   output after the direction has
**                                   been switched to output
**                                   (SetDir(TRUE);)
**           b) direction = Output : directly writes "0" to the
**                                   appropriate pin
**     Parameters  : None
**     Returns     : Nothing
** ===================================================================
*/
#define SPI_FS_CS_ClrVal() ((Shadow_GPIO_B_DR &= ~SPI_FS_CS_PIN_MASK), (clrRegBits(GPIO_B_DR,SPI_FS_CS_PIN_MASK)))

/*
** ===================================================================
**     Method      :  SPI_FS_CS_SetVal (bean BitIO)
**
**     Description :
**         This method sets (sets to one) the output value.
**           a) direction = Input  : sets the output value to "1";
**                                   this operation will be shown on
**                                   output after the direction has
**                                   been switched to output
**                                   (SetDir(TRUE);)
**           b) direction = Output : directly writes "1" to the
**                                   appropriate pin
**     Parameters  : None
**     Returns     : Nothing
** ===================================================================
*/
#define SPI_FS_CS_SetVal() ((Shadow_GPIO_B_DR |= SPI_FS_CS_PIN_MASK), (setRegBits(GPIO_B_DR,SPI_FS_CS_PIN_MASK)))


/* END SPI_FS_CS. */

#endif /* __SPI_FS_CS_H*/
/*
** ###################################################################
**
**     This file was created by UNIS Processor Expert 2.99 [04.17]
**     for the Freescale 56800 series of microcontrollers.
**
** ###################################################################
*/
