/** ###################################################################
**     THIS BEAN MODULE IS GENERATED BY THE TOOL. DO NOT MODIFY IT.
**     Filename  : Term1.C
**     Project   : DC17
**     Processor : MC56F8006_32_LQFP
**     Beantype  : Term
**     Version   : Bean 02.028, Driver 03.18, CPU db: 3.00.169
**     Compiler  : Metrowerks DSP C Compiler
**     Date/Time : 8/2/2009, 7:31 PM
**     Abstract  :
**
**     Settings  :
**
**     Contents  :
**         CRLF         - void Term1_CRLF(void);
**         SendStr      - void Term1_SendStr(uint8_t *str);
**         SendNum      - void Term1_SendNum(int32_t number);
**         SendFloatNum - void Term1_SendFloatNum(float number);
**         SendChar     - void Term1_SendChar(uint8_t Val);
**         Cls          - void Term1_Cls(void);
**         CursorUp     - void Term1_CursorUp(uint8_t lines);
**         CursorDown   - void Term1_CursorDown(uint8_t lines);
**         CursorLeft   - void Term1_CursorLeft(uint8_t columns);
**         CursorRight  - void Term1_CursorRight(uint8_t columns);
**         MoveTo       - void Term1_MoveTo(uint8_t x, uint8_t y);
**         SetColor     - void Term1_SetColor(uint8_t foreground, uint8_t background);
**         EraseLine    - void Term1_EraseLine(void);
**         ReadChar     - void Term1_ReadChar(uint8_t *c);
**         KeyPressed   - bool Term1_KeyPressed(void);
**         ReadLine     - void Term1_ReadLine(uint8_t *str);
**
**     (c) Copyright UNIS, a.s. 1997-2008
**     UNIS, a.s.
**     Jundrovska 33
**     624 00 Brno
**     Czech Republic
**     http      : www.processorexpert.com
**     mail      : info@processorexpert.com
** ###################################################################*/


/* MODULE Term1. */
#include "Term1.h"
#include "Inhr6.h"


#define COLUMNS  80                    /* Number of columns */
#define ROWS     24                    /* Number of rows */

static uint8_t BColor = clWhite;       /* Background color */
static uint8_t FColor = clBlack;       /* Foreground color */

/* Internal method prototypes */
static void SendESCPrefix(void);
static void LongToStr(void *s, int32_t n);
/*lint -save -e970 Disable MISRA rule (13) checking. */
static void FloatToStr(void *s, float n);
/*lint -restore */

/*
** ===================================================================
**     Method      :  Term1_ReadLine (bean Term)
**
**     Description :
**         Read string from the terminal. Waits until whole string
**         is read. Method expects carriage return and line feed
**         (CRLF) escape sequence as a string termination.
**     Parameters  :
**         NAME            - DESCRIPTION
**       * str             - Pointer to an user string buffer.
**     Returns     : Nothing
** ===================================================================
*/
void Term1_ReadLine(void *str)
{
  uint8_t *ptr =  ((uint8_t *) str);
  uint8_t c;

  do {                                 /* While not CR */
    while(Inhr6_RecvChar(&c) != ERR_OK){} /* Read character from terminal */
    *ptr++ = (uint8_t)c;               /* Append character to the string */
  } while ((c != '\r') && (c != '\n'));
  *--ptr = '\0';                       /* Null terminated string */
}

/*
** ===================================================================
**     Method      :  Term1_SendChar (bean Term)
**
**     Description :
**         Send char to terminal.
**     Parameters  :
**         NAME            - DESCRIPTION
**         Val             - Char to send
**     Returns     : Nothing
** ===================================================================
*/
void Term1_SendChar(uint8_t Val)
{
  while (Inhr6_SendChar(Val) == ERR_TXFULL){} /* Send char */
}

/*
** ===================================================================
**     Method      :  Term1_SendESCPrefix (bean Term)
**
**     Description :
**         The method sends first (common) part of an excape sequence
**         This method is internal. It is used by Processor Expert only.
** ===================================================================
*/
static void SendESCPrefix(void)
{
  while (Inhr6_SendChar((uint8_t) 0x1B) == ERR_TXFULL){} /* Send the part of the escape sequence */
  while (Inhr6_SendChar((uint8_t) 0x5B) == ERR_TXFULL){} /* Send the part of the escape sequence */
}

/*
** ===================================================================
**     Method      :  Term1_ReadChar (bean Term)
**
**     Description :
**         Read char from terminal.
**     Parameters  :
**         NAME            - DESCRIPTION
**       * c               - Pointer to a char variable
**     Returns     : Nothing
** ===================================================================
*/
void Term1_ReadChar(uint8_t *c)
{
  while(Inhr6_RecvChar(c) != ERR_OK){} /* Receive char */
}

/*
** ===================================================================
**     Method      :  Term1_KeyPressed (bean Term)
**
**     Description :
**         Test if char was received from the terminal.
**     Parameters  : None
**     Returns     :
**         ---             - Return TRUE if user pressed some key
** ===================================================================
*/
bool Term1_KeyPressed(void)
{
  return (bool)((Inhr6_GetCharsInRxBuf() == 0) ? FALSE : TRUE); /* Result number of chars in receive buffer */
}

/*
** ===================================================================
**     Method      :  Term1_CRLF (bean Term)
**
**     Description :
**         Send CRLF to terminal.
**     Parameters  : None
**     Returns     : Nothing
** ===================================================================
*/
void Term1_CRLF(void)
{
  while (Inhr6_SendChar((uint8_t) 13) == ERR_TXFULL){} /* Send the part of the escape sequence */
  while (Inhr6_SendChar((uint8_t) 10) == ERR_TXFULL){} /* Send the part of the escape sequence */
}

/*
** ===================================================================
**     Method      :  Term1_SendStr (bean Term)
**
**     Description :
**         Send string to terminal.
**     Parameters  :
**         NAME            - DESCRIPTION
**       * str             - Pointer to a string variable
**     Returns     : Nothing
** ===================================================================
*/
void Term1_SendStr(void *str)
{
  uint8_t *ptr =  ((uint8_t *) str);
  while (*ptr != '\0') {
    while (Inhr6_SendChar(*ptr) == ERR_TXFULL){} /* Send char */
    ptr++;                             /* Increment the pointer */
  }
}

/*
** ===================================================================
**     Method      :  Term1_LongToStr (bean Term)
**
**     Description :
**         The method converts long int number to string.
**         This method is internal. It is used by Processor Expert only.
** ===================================================================
*/
static void LongToStr(void *s, int32_t n)
{
  uint8_t *ptr =  ((uint8_t *) s);
  uint8_t i=0, j;
  uint8_t tmp;
  bool sign = (bool)(n < 0);

  if (sign){
    n *= -1;
  }
  if (n == 0){
    ptr[i++] = '0';
  }
  while (n > 0) {
    ptr[i++] = (uint8_t)((n % 10) + '0');
    n /= 10;
  }
  if (sign){
    ptr[i++] = '-';
  }
  for(j=0; j<(i/2); j++) {
    tmp = ptr[j];
    ptr[j] = ptr[(i-j)-1];
    ptr[(i-j)-1] = tmp;
  }
  ptr[i] = '\0';
}

/*
** ===================================================================
**     Method      :  Term1_SendNum (bean Term)
**
**     Description :
**         Send number to terminal.
**     Parameters  :
**         NAME            - DESCRIPTION
**         number          - Long number
**     Returns     : Nothing
** ===================================================================
*/
void Term1_SendNum(int32_t number)
{
  uint8_t str[15];                     /* Temporary variable */
  uint8_t i=0;                         /* Temporary variable */

  LongToStr(str, number);              /* Conversion number to the string */
  while (str[i] != '\0') {
    while (Inhr6_SendChar((uint8_t)str[i]) == ERR_TXFULL){} /* Send char */
    i++;                               /* Increase the variable */
  }
}

/*
** ===================================================================
**     Method      :  Term1_FloatToStr (bean Term)
**
**     Description :
**         The method converts float number to string.
**         This method is internal. It is used by Processor Expert only.
** ===================================================================
*/
/*lint -save -e970 Disable MISRA rule (13) checking. */
static void FloatToStr(void *s, float n)
{
  uint8_t *ptr =  ((uint8_t *) s);
  uint8_t i=4, j;
  uint8_t tmp;
  bool sign = (bool)(n < 0);
  uint32_t trunc;
  uint32_t fract;

  if (sign){
    n *= -1;
  }
  trunc = (uint32_t)n;
  fract = (uint32_t)((n-(uint32_t)n)*10000);
  if (fract == 0){
    ptr[i++] = '0';
  }
  for(j=0; j<4; j++) {
    ptr[j] = (uint8_t)((fract % 10) + '0');
    fract /= 10;
  }
  ptr[i++] = '.';
  if (trunc == 0){
    ptr[i++] = '0';
  }
  while (trunc > 0) {
    ptr[i++] = (uint8_t)((trunc % 10) + '0');
    trunc /= 10;
  }
  if (sign){
    ptr[i++] = '-';
  }
  for(j=0; j<(i/2); j++) {
    tmp = ptr[j];
    ptr[j] = ptr[(i-j)-1];
    ptr[(i-j)-1] = tmp;
  }
  ptr[i] = '\0';
}

/*lint -restore */
/*
** ===================================================================
**     Method      :  Term1_SendFloatNum (bean Term)
**
**     Description :
**         Send a float number to the terminal. Due to the
**         transformations the maximum float number is limited to
**         unsigned 32bit value for integer part and trim of four
**         digits for fractionals.
**     Parameters  :
**         NAME            - DESCRIPTION
**         number          - Float variable
**     Returns     : Nothing
** ===================================================================
*/
/*lint -save -e970 Disable MISRA rule (13) checking. */
void Term1_SendFloatNum(float number)
{
  uint8_t str[15];
  uint8_t i=0;

  FloatToStr(str, number);             /* Conversion number to the string */
  while (str[i] != '\0') {
    while (Inhr6_SendChar((uint8_t)str[i]) == ERR_TXFULL){} /* Send char */
    i++;                               /* Increase the variable */
  }
}

/*lint -restore */
/*
** ===================================================================
**     Method      :  Term1_Cls (bean Term)
**
**     Description :
**         Clear the terminal window.
**     Parameters  : None
**     Returns     : Nothing
** ===================================================================
*/
void Term1_Cls(void)
{
  SendESCPrefix();
  while (Inhr6_SendChar((uint8_t) '2') == ERR_TXFULL){} /* Send the part of the escape sequence */
  while (Inhr6_SendChar((uint8_t) 'J') == ERR_TXFULL){} /* Send the part of the escape sequence */
}

/*
** ===================================================================
**     Method      :  Term1_CursorUp (bean Term)
**
**     Description :
**         Move cursor up.
**     Parameters  :
**         NAME            - DESCRIPTION
**         lines           - Number of rows for shift cursor up.
**     Returns     : Nothing
** ===================================================================
*/
void Term1_CursorUp(uint8_t lines)
{
  SendESCPrefix();                     /* Send the escape prefix */
  Term1_SendNum((int32_t) lines);      /* Send number of lines */
  while (Inhr6_SendChar((uint8_t) 'A') == ERR_TXFULL){} /* Send the part of the escape sequence */
}

/*
** ===================================================================
**     Method      :  Term1_CursorDown (bean Term)
**
**     Description :
**         Move cursor down.
**     Parameters  :
**         NAME            - DESCRIPTION
**         lines           - Number of rows for shift cursor
**                           down..
**     Returns     : Nothing
** ===================================================================
*/
void Term1_CursorDown(uint8_t lines)
{
  SendESCPrefix();                     /* Send the escape prefix */
  Term1_SendNum((int32_t) lines);      /* Send number of lines */
  while (Inhr6_SendChar((uint8_t) 'B') == ERR_TXFULL){} /* Send the part of the escape sequence */
}

/*
** ===================================================================
**     Method      :  Term1_CursorLeft (bean Term)
**
**     Description :
**         Move cursor left.
**     Parameters  :
**         NAME            - DESCRIPTION
**         columns         - Number of columns for shift
**                           cursor left
**     Returns     : Nothing
** ===================================================================
*/
void Term1_CursorLeft(uint8_t columns)
{
  SendESCPrefix();                     /* Send the escape prefix */
  Term1_SendNum((int32_t) columns);    /* Send number of columns */
  while (Inhr6_SendChar((uint8_t) 'D') == ERR_TXFULL){} /* Send the part of the escape sequence */
}

/*
** ===================================================================
**     Method      :  Term1_CursorRight (bean Term)
**
**     Description :
**         Move cursor right.
**     Parameters  :
**         NAME            - DESCRIPTION
**         columns         - Number of columns for shift
**                           cursor right
**     Returns     : Nothing
** ===================================================================
*/
void Term1_CursorRight(uint8_t columns)
{
  SendESCPrefix();                     /* Send the escape prefix */
  Term1_SendNum((int32_t) columns);    /* Send number of columns */
  while (Inhr6_SendChar((uint8_t) 'C') == ERR_TXFULL){} /* Send the part of the escape sequence */
}

/*
** ===================================================================
**     Method      :  Term1_MoveTo (bean Term)
**
**     Description :
**         Move cursor to position x, y. Range of coordinates can be
**         from 1 to the size, which depends on the used terminal.
**         Position [1,1] represents the upper left corner.
**     Parameters  :
**         NAME            - DESCRIPTION
**         x               - Column number
**         y               - Row number
**     Returns     : Nothing
** ===================================================================
*/
void Term1_MoveTo(uint8_t x,uint8_t y)
{
  SendESCPrefix();                     /* Send the escape prefix */
  Term1_SendNum((int32_t) y);          /* Send number of line */
  while (Inhr6_SendChar((uint8_t) ';') == ERR_TXFULL){} /* Send the part of the escape sequence */
  Term1_SendNum((int32_t) x);          /* Send number of column */
  while (Inhr6_SendChar((uint8_t) 'H') == ERR_TXFULL){} /* Send the part of the escape sequence */
}

/*
** ===================================================================
**     Method      :  Term1_SetColor (bean Term)
**
**     Description :
**         Set foreground and background color. The following color
**         constant are defined in the header file:
**         clBlack - Black color
**         clRed - Red color
**         clGreen - Green color
**         clYellow - Yellow color
**         clBlue - Blue color
**         clMagenta - Magenta color
**         clCyan - Cyan color
**         clWhite - White color
**     Parameters  :
**         NAME            - DESCRIPTION
**         foreground      - Foreground color.
**         background      - Background color.
**     Returns     : Nothing
** ===================================================================
*/
void Term1_SetColor(uint8_t foreground,uint8_t background)
{
  SendESCPrefix();                     /* Send the escape prefix */
  while (Inhr6_SendChar((uint8_t) '0') == ERR_TXFULL){} /* Send text atributes */
  while (Inhr6_SendChar((uint8_t) ';') == ERR_TXFULL){} /* Send the part of the escape sequence */
  Term1_SendNum((int32_t) foreground); /* Send the foreground color */
  while (Inhr6_SendChar((uint8_t) ';') == ERR_TXFULL){} /* Send the part of the escape sequence */
  Term1_SendNum((int32_t) (background+10)); /* Send the background color */
  while (Inhr6_SendChar((uint8_t) 'm') == ERR_TXFULL){} /* Send the part of the escape sequence */
  BColor = background;                 /* Set the temporary variable */
  FColor = foreground;                 /* Set the temporary variable */
}

/*
** ===================================================================
**     Method      :  Term1_EraseLine (bean Term)
**
**     Description :
**         Clears the current line from the cursor position to the
**         end of line.
**     Parameters  : None
**     Returns     : Nothing
** ===================================================================
*/
void Term1_EraseLine(void)
{
  SendESCPrefix();                     /* Send the escape prefix */
  while (Inhr6_SendChar((uint8_t) 'K') == ERR_TXFULL){} /* Send the part of the escape sequence */
}


/* END Term1. */

/*
** ###################################################################
**
**     This file was created by UNIS Processor Expert 2.99 [04.17]
**     for the Freescale 56800 series of microcontrollers.
**
** ###################################################################
*/

