/** ###################################################################
**     THIS BEAN MODULE IS GENERATED BY THE TOOL. DO NOT MODIFY IT.
**     Filename  : Term1.H
**     Project   : DC17
**     Processor : MC56F8006_32_LQFP
**     Beantype  : Term
**     Version   : Bean 02.028, Driver 03.18, CPU db: 3.00.169
**     Compiler  : Metrowerks DSP C Compiler
**     Date/Time : 8/2/2009, 7:31 PM
**     Abstract  :
**
**     Settings  :
**
**     Contents  :
**         CRLF         - void Term1_CRLF(void);
**         SendStr      - void Term1_SendStr(uint8_t *str);
**         SendNum      - void Term1_SendNum(int32_t number);
**         SendFloatNum - void Term1_SendFloatNum(float number);
**         SendChar     - void Term1_SendChar(uint8_t Val);
**         Cls          - void Term1_Cls(void);
**         CursorUp     - void Term1_CursorUp(uint8_t lines);
**         CursorDown   - void Term1_CursorDown(uint8_t lines);
**         CursorLeft   - void Term1_CursorLeft(uint8_t columns);
**         CursorRight  - void Term1_CursorRight(uint8_t columns);
**         MoveTo       - void Term1_MoveTo(uint8_t x, uint8_t y);
**         SetColor     - void Term1_SetColor(uint8_t foreground, uint8_t background);
**         EraseLine    - void Term1_EraseLine(void);
**         ReadChar     - void Term1_ReadChar(uint8_t *c);
**         KeyPressed   - bool Term1_KeyPressed(void);
**         ReadLine     - void Term1_ReadLine(uint8_t *str);
**
**     (c) Copyright UNIS, a.s. 1997-2008
**     UNIS, a.s.
**     Jundrovska 33
**     624 00 Brno
**     Czech Republic
**     http      : www.processorexpert.com
**     mail      : info@processorexpert.com
** ###################################################################*/

#ifndef __Term1
#define __Term1

/*Include shared modules, which are used for whole project*/
#include "PE_Types.h"
#include "PE_Error.h"
#include "PE_Const.h"
#include "IO_Map.h"

/* MODULE Term1. */

#include "Cpu.h"


/* Color constants */
#define   clBlack   30                 /* Black color */
#define   clRed     31                 /* Red color */
#define   clGreen   32                 /* Green color */
#define   clYellow  33                 /* Yellow color */
#define   clBlue    34                 /* Blue color */
#define   clMagenta 35                 /* Magenta color */
#define   clCyan    36                 /* Cyan color */
#define   clWhite   37                 /* White color */

void Term1_ReadLine(void *str);
/*
** ===================================================================
**     Method      :  Term1_ReadLine (bean Term)
**
**     Description :
**         Read string from the terminal. Waits until whole string
**         is read. Method expects carriage return and line feed
**         (CRLF) escape sequence as a string termination.
**     Parameters  :
**         NAME            - DESCRIPTION
**       * str             - Pointer to an user string buffer.
**     Returns     : Nothing
** ===================================================================
*/

void Term1_SendChar(uint8_t Val);
/*
** ===================================================================
**     Method      :  Term1_SendChar (bean Term)
**
**     Description :
**         Send char to terminal.
**     Parameters  :
**         NAME            - DESCRIPTION
**         Val             - Char to send
**     Returns     : Nothing
** ===================================================================
*/

void Term1_ReadChar(uint8_t *c);
/*
** ===================================================================
**     Method      :  Term1_ReadChar (bean Term)
**
**     Description :
**         Read char from terminal.
**     Parameters  :
**         NAME            - DESCRIPTION
**       * c               - Pointer to a char variable
**     Returns     : Nothing
** ===================================================================
*/

bool Term1_KeyPressed(void);
/*
** ===================================================================
**     Method      :  Term1_KeyPressed (bean Term)
**
**     Description :
**         Test if char was received from the terminal.
**     Parameters  : None
**     Returns     :
**         ---             - Return TRUE if user pressed some key
** ===================================================================
*/

void Term1_CRLF(void);
/*
** ===================================================================
**     Method      :  Term1_CRLF (bean Term)
**
**     Description :
**         Send CRLF to terminal.
**     Parameters  : None
**     Returns     : Nothing
** ===================================================================
*/

void Term1_SendStr(void *str);
/*
** ===================================================================
**     Method      :  Term1_SendStr (bean Term)
**
**     Description :
**         Send string to terminal.
**     Parameters  :
**         NAME            - DESCRIPTION
**       * str             - Pointer to a string variable
**     Returns     : Nothing
** ===================================================================
*/

void Term1_SendNum(int32_t number);
/*
** ===================================================================
**     Method      :  Term1_SendNum (bean Term)
**
**     Description :
**         Send number to terminal.
**     Parameters  :
**         NAME            - DESCRIPTION
**         number          - Long number
**     Returns     : Nothing
** ===================================================================
*/

/*lint -save -e970 Disable MISRA rule (13) checking. */
void Term1_SendFloatNum(float number);
/*lint -restore */
/*
** ===================================================================
**     Method      :  Term1_SendFloatNum (bean Term)
**
**     Description :
**         Send a float number to the terminal. Due to the
**         transformations the maximum float number is limited to
**         unsigned 32bit value for integer part and trim of four
**         digits for fractionals.
**     Parameters  :
**         NAME            - DESCRIPTION
**         number          - Float variable
**     Returns     : Nothing
** ===================================================================
*/

void Term1_Cls(void);
/*
** ===================================================================
**     Method      :  Term1_Cls (bean Term)
**
**     Description :
**         Clear the terminal window.
**     Parameters  : None
**     Returns     : Nothing
** ===================================================================
*/

void Term1_CursorUp(uint8_t lines);
/*
** ===================================================================
**     Method      :  Term1_CursorUp (bean Term)
**
**     Description :
**         Move cursor up.
**     Parameters  :
**         NAME            - DESCRIPTION
**         lines           - Number of rows for shift cursor up.
**     Returns     : Nothing
** ===================================================================
*/

void Term1_CursorDown(uint8_t lines);
/*
** ===================================================================
**     Method      :  Term1_CursorDown (bean Term)
**
**     Description :
**         Move cursor down.
**     Parameters  :
**         NAME            - DESCRIPTION
**         lines           - Number of rows for shift cursor
**                           down..
**     Returns     : Nothing
** ===================================================================
*/

void Term1_CursorLeft(uint8_t columns);
/*
** ===================================================================
**     Method      :  Term1_CursorLeft (bean Term)
**
**     Description :
**         Move cursor left.
**     Parameters  :
**         NAME            - DESCRIPTION
**         columns         - Number of columns for shift
**                           cursor left
**     Returns     : Nothing
** ===================================================================
*/

void Term1_CursorRight(uint8_t columns);
/*
** ===================================================================
**     Method      :  Term1_CursorRight (bean Term)
**
**     Description :
**         Move cursor right.
**     Parameters  :
**         NAME            - DESCRIPTION
**         columns         - Number of columns for shift
**                           cursor right
**     Returns     : Nothing
** ===================================================================
*/

void Term1_MoveTo(uint8_t x,uint8_t y);
/*
** ===================================================================
**     Method      :  Term1_MoveTo (bean Term)
**
**     Description :
**         Move cursor to position x, y. Range of coordinates can be
**         from 1 to the size, which depends on the used terminal.
**         Position [1,1] represents the upper left corner.
**     Parameters  :
**         NAME            - DESCRIPTION
**         x               - Column number
**         y               - Row number
**     Returns     : Nothing
** ===================================================================
*/

void Term1_SetColor(uint8_t foreground,uint8_t background);
/*
** ===================================================================
**     Method      :  Term1_SetColor (bean Term)
**
**     Description :
**         Set foreground and background color. The following color
**         constant are defined in the header file:
**         clBlack - Black color
**         clRed - Red color
**         clGreen - Green color
**         clYellow - Yellow color
**         clBlue - Blue color
**         clMagenta - Magenta color
**         clCyan - Cyan color
**         clWhite - White color
**     Parameters  :
**         NAME            - DESCRIPTION
**         foreground      - Foreground color.
**         background      - Background color.
**     Returns     : Nothing
** ===================================================================
*/

void Term1_EraseLine(void);
/*
** ===================================================================
**     Method      :  Term1_EraseLine (bean Term)
**
**     Description :
**         Clears the current line from the cursor position to the
**         end of line.
**     Parameters  : None
**     Returns     : Nothing
** ===================================================================
*/


/* END Term1. */

#endif /* ifndef __Term1 */
/*
** ###################################################################
**
**     This file was created by UNIS Processor Expert 2.99 [04.17]
**     for the Freescale 56800 series of microcontrollers.
**
** ###################################################################
*/
