/*******************************************************************************
   Copyright 2008, 2009 Wearable Inc.; An Illinois, United States Corporation

   Licensed under the Apache License, Version 2.0 (the "License");
   you may not use this file except in compliance with the License.
   You may obtain a copy of the License at

       http://www.apache.org/licenses/LICENSE-2.0

   Unless required by applicable law or agreed to in writing, software
   distributed under the License is distributed on an "AS IS" BASIS,
   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
   See the License for the specific language governing permissions and
   limitations under the License.
*******************************************************************************/
/*******************************************************************************
   Name:        DOSonCHIP(TM) Packet Communications Definitions
   File Name:   DOSpacket.h
   Description: Definitions to communicate packets between host and DOSonCHIP IC.
*******************************************************************************/

#ifndef DOSPACKET_H
#define DOSPACKET_H

/* GLOBAL VARIABLES */
extern unsigned char DOSpacketPayloadLengthName;   /* current DATA_NAME packet payload length */
extern unsigned int  DOSpacketPayloadLengthBlock;  /* current DATA_BLOCK packet payload length */
extern unsigned char DOScurrentHandle;             /* current handle */

/* FUNCTION PROTOTYPES */
unsigned char DOSpacketPut (unsigned char header, unsigned char *payload); /* Transmit a packet to DOSonCHIP */
void          DOSpacketPutBlock (unsigned char *payload);   /* Transmit a DOS_DATA_BLOCK packet to DOSonCHIP */
unsigned char DOSpacketGet (unsigned char *payload); /* Receive a packet from DOSonCHIP */
unsigned char DOSpacketGetResponse (void);           /* Receive a response packet from DOSonCHIP */

#endif